searchData={"content_type":"text/markdown","items":[{"doc":"Methods to handle configurations.","ref":"Assent.Config.html","title":"Assent.Config","type":"module"},{"doc":"Fetches the key value from the configuration.","ref":"Assent.Config.html#fetch/2","title":"Assent.Config.fetch/2","type":"function"},{"doc":"","ref":"Assent.Config.html#get/3","title":"Assent.Config.get/3","type":"function"},{"doc":"Fetches the JSON library in config.\n\nIf not found in provided config, this will attempt to load the JSON library\nfrom global application environment for `:assent`. Defaults to `Jason`.","ref":"Assent.Config.html#json_library/1","title":"Assent.Config.json_library/1","type":"function"},{"doc":"","ref":"Assent.Config.html#merge/2","title":"Assent.Config.merge/2","type":"function"},{"doc":"","ref":"Assent.Config.html#put/3","title":"Assent.Config.put/3","type":"function"},{"doc":"","ref":"Assent.Config.html#t:t/0","title":"Assent.Config.t/0","type":"type"},{"doc":"Used for creating strategies.","ref":"Assent.Strategy.html","title":"Assent.Strategy","type":"behaviour"},{"doc":"Set up `my_strategy.ex` the following way:\n\n    defmodule MyStrategy do\n      @behaviour Assent.Strategy\n\n      alias Assent.Strategy, as: Helpers\n\n      def authorize_url(config) do\n        # Generate redirect URL\n\n        {:ok, %{url: url, ...}}\n      end\n\n      def callback(config, params) do\n        # Fetch user data\n\n        user = Helpers.normalize_userinfo(userinfo)\n\n        {:ok, %{user: user, ...}}\n      end\n    end","ref":"Assent.Strategy.html#module-usage","title":"Usage - Assent.Strategy","type":"behaviour"},{"doc":"","ref":"Assent.Strategy.html#c:authorize_url/1","title":"Assent.Strategy.authorize_url/1","type":"callback"},{"doc":"","ref":"Assent.Strategy.html#c:callback/2","title":"Assent.Strategy.callback/2","type":"callback"},{"doc":"Decode a JSON response to a map","ref":"Assent.Strategy.html#decode_json/2","title":"Assent.Strategy.decode_json/2","type":"function"},{"doc":"Decodes a request response.","ref":"Assent.Strategy.html#decode_response/2","title":"Assent.Strategy.decode_response/2","type":"function"},{"doc":"Normalize API user request response into standard claims\n\nBased on https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1","ref":"Assent.Strategy.html#normalize_userinfo/2","title":"Assent.Strategy.normalize_userinfo/2","type":"function"},{"doc":"Recursively prunes map for nil values.","ref":"Assent.Strategy.html#prune/1","title":"Assent.Strategy.prune/1","type":"function"},{"doc":"Makes a HTTP request.","ref":"Assent.Strategy.html#request/5","title":"Assent.Strategy.request/5","type":"function"},{"doc":"Signs a JWT","ref":"Assent.Strategy.html#sign_jwt/4","title":"Assent.Strategy.sign_jwt/4","type":"function"},{"doc":"Generates a URL","ref":"Assent.Strategy.html#to_url/3","title":"Assent.Strategy.to_url/3","type":"function"},{"doc":"Verifies a JWT","ref":"Assent.Strategy.html#verify_jwt/3","title":"Assent.Strategy.verify_jwt/3","type":"function"},{"doc":"Apple Sign In OAuth 2.0 strategy.\n\nYou'll need to collect the 10-char long Team ID, the Services ID, the 10-char\nKey ID and download the private key from the portal. Save the private key to\nan accessible folder, or alternatively set `:private_key` with the content of\nthe private key.","ref":"Assent.Strategy.Apple.html","title":"Assent.Strategy.Apple","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_SERVICES_ID\",\n      team_id: \"REPLACE_WITH_TEAM_ID\",\n      private_key_id: \"REPLACE_WITH_PRIVATE_KEY_ID\",\n      private_key_path: \"/path/to/key.p8\"\n    ]","ref":"Assent.Strategy.Apple.html#module-usage","title":"Usage - Assent.Strategy.Apple","type":"module"},{"doc":"You can use the JS SDK instead of handling it through `auhorize_url/2`. All you\nhave to do is to set up you HTML page with the following way:\n\n     \n       \n           \n           \n           \n           \n       \n       \n            \n            \n       \n     \n\nYou can get the state by generating the session params using the\n`authorize_url/2`:\n\n    {:ok, %{session_params: session_params}} = Assent.Strategy.Apple.authorize_url(config)\n\nUse the `session_params[:state]` value for `[STATE]`. The callback phase\nwould be identical to how it's explained in the [README](README.md).\n\nSee https://developer.apple.com/documentation/signinwithapplejs/configuring_your_webpage_for_sign_in_with_apple\nfor more.","ref":"Assent.Strategy.Apple.html#module-with-js-sdk","title":"With JS SDK - Assent.Strategy.Apple","type":"module"},{"doc":"Auth0 OAuth 2.0 strategy.","ref":"Assent.Strategy.Auth0.html","title":"Assent.Strategy.Auth0","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      domain: \"REPLACE_WITH_DOMAIN\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Auth0.html#module-usage","title":"Usage - Assent.Strategy.Auth0","type":"module"},{"doc":"Azure Active Directory OpenID Connect strategy.","ref":"Assent.Strategy.AzureAD.html","title":"Assent.Strategy.AzureAD","type":"module"},{"doc":"- `:tenant_id` - The Azure tenant ID, optional, defaults to `common`\n\nSee `Assent.Strategy.OIDC` for more.","ref":"Assent.Strategy.AzureAD.html#module-configuration","title":"Configuration - Assent.Strategy.AzureAD","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nA tenant id can be set to limit scope of users who can get access (defaults\nto \"common\"):\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      tenant_id: \"REPLACE_WITH_TENANT_ID\"\n    ]","ref":"Assent.Strategy.AzureAD.html#module-usage","title":"Usage - Assent.Strategy.AzureAD","type":"module"},{"doc":"Login to Azure, and set up a new application:\nhttps://docs.microsoft.com/en-us/azure/active-directory/develop/quickstart-register-app\n\n* The callback URL should be added to \"Redirect URI\" for the application.\n* `client_id` is the \"Application ID\".","ref":"Assent.Strategy.AzureAD.html#module-setting-up-azure-ad","title":"Setting up Azure AD - Assent.Strategy.AzureAD","type":"module"},{"doc":"Basecamp OAuth 2.0 strategy.\n\nIn the normalized user response a `basecamp_accounts` field is included that\ncan be used to limit access to users belonging to a particular account.\n\nThe Basecamp user endpoint does not provide data on email verification, email\nis considered unverified.","ref":"Assent.Strategy.Basecamp.html","title":"Assent.Strategy.Basecamp","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Basecamp.html#module-usage","title":"Usage - Assent.Strategy.Basecamp","type":"module"},{"doc":"DigitalOcean OAuth 2.0 strategy.","ref":"Assent.Strategy.DigitalOcean.html","title":"Assent.Strategy.DigitalOcean","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.DigitalOcean.html#module-usage","title":"Usage - Assent.Strategy.DigitalOcean","type":"module"},{"doc":"Discord OAuth 2.0 strategy.","ref":"Assent.Strategy.Discord.html","title":"Assent.Strategy.Discord","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Discord.html#module-usage","title":"Usage - Assent.Strategy.Discord","type":"module"},{"doc":"Facebook OAuth 2.0 strategy.\n\nThe Facebook user endpoint does not provide data on email verification, email\nis considered unverified. More here:\nhttps://developers.facebook.com/docs/facebook-login/multiple-providers#postfb1","ref":"Assent.Strategy.Facebook.html","title":"Assent.Strategy.Facebook","type":"module"},{"doc":"- `:user_url_request_fields` - The fields for the resource, defaults to\n  `email,name,first_name,last_name,middle_name,link`\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Facebook.html#module-configuration","title":"Configuration - Assent.Strategy.Facebook","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Facebook.html#module-usage","title":"Usage - Assent.Strategy.Facebook","type":"module"},{"doc":"You can use the JS SDK instead of handling it through `auhorize_url/2`. All\nyou have to do is to set up you HTML page with the following way:\n\n     \n     \n     \n     \n\n     \n      function checkLoginState() {\n        FB.getLoginStatus(function(response) {\n          let signedRequest = response.authResponse.signedRequest\n          let encodedPayload = atob(signedRequest.split('.')[1])\n          let payload = JSON.parse(encodedPayload)\n\n          window.location.href = ' ?&code=' + encodeURI(payload.code)\n        });\n      }\n\n      window.fbAsyncInit = function() {\n        FB.init({\n          appId   : '[CLIENT_ID]',\n          cookie  : true, // required for server to pick up session\n          version : 'v6.0',\n          xfbml   : true\n        });\n      };\n     \n      \n\nIn the above, the signed request is decoded and the authorization code is\nfetched from it. The `@redirect_uri` is the callback URL.\n\nYou have to use an empty `redirect_uri` for the callback:\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Assent.Config.put(:redirect_uri, \"\")\n      |> Assent.Strategy.Facebook.callback(params)","ref":"Assent.Strategy.Facebook.html#module-with-js-sdk","title":"With JS SDK - Assent.Strategy.Facebook","type":"module"},{"doc":"Github OAuth 2.0 strategy.","ref":"Assent.Strategy.Github.html","title":"Assent.Strategy.Github","type":"module"},{"doc":"- `:user_emails_url` - The API path or URL to fetch e-mails from, defaults to `/user/emails`\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Github.html#module-configuration","title":"Configuration - Assent.Strategy.Github","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Github.html#module-usage","title":"Usage - Assent.Strategy.Github","type":"module"},{"doc":"Gitlab OAuth 2.0 strategy.","ref":"Assent.Strategy.Gitlab.html","title":"Assent.Strategy.Gitlab","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Gitlab.html#module-usage","title":"Usage - Assent.Strategy.Gitlab","type":"module"},{"doc":"Google OAuth 2.0 strategy.\n\nIn the normalized user response a `google_hd` (\"Hosted Domain\") field is\nincluded in user parameters and can be used to limit access to users\nbelonging to a particular hosted domain.","ref":"Assent.Strategy.Google.html","title":"Assent.Strategy.Google","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nTo get the refresh token, it's necessary to pass `access_type: \"offline\"` in\nthe authorization request:\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      authorization_params: [\n        access_type: \"offline\",\n        scope: \"https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile\"\n      ]\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Google.html#module-usage","title":"Usage - Assent.Strategy.Google","type":"module"},{"doc":"Instagram OAuth 2.0 strategy.\n\nThe Instagram user object does not provide data on email verification, email\nis considered unverified.","ref":"Assent.Strategy.Instagram.html","title":"Assent.Strategy.Instagram","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Instagram.html#module-usage","title":"Usage - Assent.Strategy.Instagram","type":"module"},{"doc":"LINE Login OpenID Connect Strategy.","ref":"Assent.Strategy.LINE.html","title":"Assent.Strategy.LINE","type":"module"},{"doc":"config = [\n    client_id: \"REPLACE_WITH_CLIENT_ID\",\n    client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n  ]\n\nSee `Assent.Strategy.OIDC` for more.","ref":"Assent.Strategy.LINE.html#module-usage","title":"Usage - Assent.Strategy.LINE","type":"module"},{"doc":"Sign In with LinkedIn V2 OpenID Connect Strategy.\n\nYou'll need the `Sign In with LinkedIn v2` product enabled in your app. See the\n[LinkedIn integration guide](https://learn.microsoft.com/en-us/linkedin/consumer/integrations/self-serve/sign-in-with-linkedin-v2)\nfor more.","ref":"Assent.Strategy.Linkedin.html","title":"Assent.Strategy.Linkedin","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OIDC` for more.","ref":"Assent.Strategy.Linkedin.html#module-usage","title":"Usage - Assent.Strategy.Linkedin","type":"module"},{"doc":"OAuth 1.0a strategy.\n\n`authorize_url/1` returns a map with a `:session_params` and `:url` key. The\n`:session_params` key carries a `:oauth_token_secret` value for the request.","ref":"Assent.Strategy.OAuth.html","title":"Assent.Strategy.OAuth","type":"module"},{"doc":"- `:consumer_key` - The OAuth consumer key, required\n  - `:site` - The domain of the OAuth server, required\n  - `:signature_method` -  The signature method, optional, defaults to\n    `:hmac_sha1`. The value may be one of the following:\n\n    - `:hmac_sha1` - Generates signature with HMAC-SHA1\n    - `:rsa_sha1` - Generates signature with RSA-SHA1\n    - `:plaintext` - Doesn't generate signature\n  - `:consumer_secret` - The OAuth consumer secret, required if\n    `:signature_method` is either `:hmac_sha1` or `:plaintext`\n  - `:private_key_path` - The path for the private key, required if\n    `:signature_method` is `:rsa_sha1` and `:private_key` hasn't been set\n  - `:private_key` - The private key content that can be defined instead of\n    `:private_key_path`, required if `:signature_method` is `:rsa_sha1` and\n    `:private_key_path` hasn't been set","ref":"Assent.Strategy.OAuth.html#module-configuration","title":"Configuration - Assent.Strategy.OAuth","type":"module"},{"doc":"config = [\n      consumer_key: \"REPLACE_WITH_CONSUMER_KEY\",\n      consumer_secret: \"REPLACE_WITH_CONSUMER_SECRET\",\n      site: \"https://auth.example.com\",\n      authorization_params: [scope: \"user:read user:write\"],\n      user_url: \"https://example.com/api/user\"\n    ]\n\n    {:ok, {url: url, session_params: session_params}} =\n      config\n      |> Assent.Config.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> OAuth.authorize_url()\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Assent.Config.put(:session_params, session_params)\n      |> OAuth.callback(params)","ref":"Assent.Strategy.OAuth.html#module-usage","title":"Usage - Assent.Strategy.OAuth","type":"module"},{"doc":"Generate authorization URL for request phase.","ref":"Assent.Strategy.OAuth.html#authorize_url/1","title":"Assent.Strategy.OAuth.authorize_url/1","type":"function"},{"doc":"- `:redirect_uri` - The URI that the server redirects the user to after\n    authentication, required\n  - `:request_token_url` - The path or URL to fetch the token from, optional,\n    defaults to `/oauth/request_token`\n  - `:authorize_url` - The path or URL for the OAuth server to redirect users\n    to, defaults to `/oauth/authenticate`\n  - `:authorization_params` - The authorization parameters, defaults to `[]`","ref":"Assent.Strategy.OAuth.html#authorize_url/1-configuration","title":"Configuration - Assent.Strategy.OAuth.authorize_url/1","type":"function"},{"doc":"Callback phase for generating access token and fetch user data.","ref":"Assent.Strategy.OAuth.html#callback/3","title":"Assent.Strategy.OAuth.callback/3","type":"function"},{"doc":"- `:access_token_url` - The path or URL to fetch the access token from,\n    optional, defaults to `/oauth/access_token`\n  - `:user_url` - The path or URL to fetch user data, required\n  - `:session_params` - The session parameters that was returned from\n    `authorize_url/1`, optional","ref":"Assent.Strategy.OAuth.html#callback/3-configuration","title":"Configuration - Assent.Strategy.OAuth.callback/3","type":"function"},{"doc":"Performs a signed HTTP request to the API using the oauth token.","ref":"Assent.Strategy.OAuth.html#request/6","title":"Assent.Strategy.OAuth.request/6","type":"function"},{"doc":"OAuth 1.0 strategy base.","ref":"Assent.Strategy.OAuth.Base.html","title":"Assent.Strategy.OAuth.Base","type":"behaviour"},{"doc":"defmodule MyApp.MyOAuthStratey do\n      use Assent.Strategy.OAuth\n\n      @impl true\n      def default_config(_config) do\n        [\n          site: \"https://api.example.com\",\n          authorize_url: \"/authorization/new\",\n          access_token_url: \"/authorization/access_token\"\n          request_token_url: \"/authorization/request_token\",\n          user_url: \"/authorization.json\",\n          authorization_params: [scope: \"default\"]\n        ]\n      end\n\n      @impl true\n      def normalize(_config, user) do\n        {:ok,\n          # Conformed to https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1\n          %{\n            \"sub\"   => user[\"id\"],\n            \"name\"  => user[\"name\"],\n            \"email\" => user[\"email\"]\n          # },\n          # # Provider specific data not part of the standard claims spec\n          # %{\n          #  \"https://example.com/bio\" => user[\"bio\"]\n          }\n        }\n      end\n    end","ref":"Assent.Strategy.OAuth.Base.html#module-usage","title":"Usage - Assent.Strategy.OAuth.Base","type":"behaviour"},{"doc":"","ref":"Assent.Strategy.OAuth.Base.html#authorize_url/2","title":"Assent.Strategy.OAuth.Base.authorize_url/2","type":"function"},{"doc":"","ref":"Assent.Strategy.OAuth.Base.html#callback/3","title":"Assent.Strategy.OAuth.Base.callback/3","type":"function"},{"doc":"","ref":"Assent.Strategy.OAuth.Base.html#c:default_config/1","title":"Assent.Strategy.OAuth.Base.default_config/1","type":"callback"},{"doc":"","ref":"Assent.Strategy.OAuth.Base.html#c:fetch_user/2","title":"Assent.Strategy.OAuth.Base.fetch_user/2","type":"callback"},{"doc":"","ref":"Assent.Strategy.OAuth.Base.html#c:normalize/2","title":"Assent.Strategy.OAuth.Base.normalize/2","type":"callback"},{"doc":"OAuth 2.0 strategy.\n\nThis strategy only supports the Authorization Code flow per\n[RFC 6749](https://tools.ietf.org/html/rfc6749#section-1.3.1).\n\n`authorize_url/1` returns a map with a `:url` and `:session_params` key. The\n`:session_params` should be stored and passed back into `callback/3` as part\nof config when the user returns. The `:session_params` carries a `:state`\nvalue for the request [to prevent\nCSRF](https://tools.ietf.org/html/rfc6749#section-4.1.1).\n\nThis library also supports JWT tokens for client authentication as per\n[RFC 7523](https://tools.ietf.org/html/rfc7523).","ref":"Assent.Strategy.OAuth2.html","title":"Assent.Strategy.OAuth2","type":"module"},{"doc":"- `:client_id` - The OAuth2 client id, required\n  - `:site` - The domain of the OAuth2 server, required\n  - `:auth_method` - The authentication strategy used, optional. If not set,\n    no authentication will be used during the access token request. The value\n    may be one of the following:\n\n    - `:client_secret_basic` - Authenticate with basic authorization header\n    - `:client_secret_post` - Authenticate with post params\n    - `:client_secret_jwt` - Authenticate with JWT using `:client_secret` as\n      secret\n    - `:private_key_jwt` - Authenticate with JWT using `:private_key_path` or\n      `:private_key` as secret\n  - `:client_secret` - The OAuth2 client secret, required if `:auth_method`\n    is `:client_secret_basic`, `:client_secret_post`, or `:client_secret_jwt`\n  - `:private_key_id` - The private key ID, required if `:auth_method` is\n    `:private_key_jwt`\n  - `:private_key_path` - The path for the private key, required if\n    `:auth_method` is `:private_key_jwt` and `:private_key` hasn't been set\n  - `:private_key` - The private key content that can be defined instead of\n    `:private_key_path`, required if `:auth_method` is `:private_key_jwt` and\n    `:private_key_path` hasn't been set\n  - `:jwt_algorithm` - The algorithm to use for JWT signing, optional,\n    defaults to `HS256` for `:client_secret_jwt` and `RS256` for\n    `:private_key_jwt`","ref":"Assent.Strategy.OAuth2.html#module-configuration","title":"Configuration - Assent.Strategy.OAuth2","type":"module"},{"doc":"config =  [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      auth_method: :client_secret_post,\n      site: \"https://auth.example.com\",\n      authorization_params: [scope: \"user:read user:write\"],\n      user_url: \"https://example.com/api/user\"\n    ]\n\n    {:ok, %{url: url, session_params: session_params}} =\n      config\n      |> Assent.Config.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> Assent.Strategy.OAuth2.authorize_url()\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Assent.Config.put(:session_params, session_params)\n      |> Assent.Strategy.OAuth2.callback(params)","ref":"Assent.Strategy.OAuth2.html#module-usage","title":"Usage - Assent.Strategy.OAuth2","type":"module"},{"doc":"Generate authorization URL for request phase.","ref":"Assent.Strategy.OAuth2.html#authorize_url/1","title":"Assent.Strategy.OAuth2.authorize_url/1","type":"function"},{"doc":"- `:redirect_uri` - The URI that the server redirects the user to after\n    authentication, required\n  - `:authorize_url` - The path or URL for the OAuth2 server to redirect\n    users to, defaults to `/oauth/authorize`\n  - `:authorization_params` - The authorization parameters, defaults to `[]`","ref":"Assent.Strategy.OAuth2.html#authorize_url/1-configuration","title":"Configuration - Assent.Strategy.OAuth2.authorize_url/1","type":"function"},{"doc":"Callback phase for generating access token with authorization code and fetch\nuser data. Returns a map with access token in `:token` and user data in\n`:user`.","ref":"Assent.Strategy.OAuth2.html#callback/3","title":"Assent.Strategy.OAuth2.callback/3","type":"function"},{"doc":"- `:token_url` - The path or URL to fetch the token from, optional,\n    defaults to `/oauth/token`\n  - `:user_url` - The path or URL to fetch user data, required\n  - `:session_params` - The session parameters that was returned from\n    `authorize_url/1`, optional","ref":"Assent.Strategy.OAuth2.html#callback/3-configuration","title":"Configuration - Assent.Strategy.OAuth2.callback/3","type":"function"},{"doc":"Fetch user data with the access token.\n\nUses `request/6` to fetch the user data.","ref":"Assent.Strategy.OAuth2.html#fetch_user/4","title":"Assent.Strategy.OAuth2.fetch_user/4","type":"function"},{"doc":"Grants an access token.","ref":"Assent.Strategy.OAuth2.html#grant_access_token/3","title":"Assent.Strategy.OAuth2.grant_access_token/3","type":"function"},{"doc":"Refreshes the access token.","ref":"Assent.Strategy.OAuth2.html#refresh_access_token/3","title":"Assent.Strategy.OAuth2.refresh_access_token/3","type":"function"},{"doc":"Performs a HTTP request to the API using the access token.","ref":"Assent.Strategy.OAuth2.html#request/6","title":"Assent.Strategy.OAuth2.request/6","type":"function"},{"doc":"OAuth 2.0 strategy base.","ref":"Assent.Strategy.OAuth2.Base.html","title":"Assent.Strategy.OAuth2.Base","type":"behaviour"},{"doc":"defmodule MyApp.MyOAuth2Strategy do\n      use Assent.Strategy.OAuth2.Base\n\n      def default_config(_config) do\n        [\n          site: \"https://api.example.com\",\n          user_url: \"/authorization.json\"\n        ]\n      end\n\n      @impl true\n      def normalize(_config, user) do\n        {:ok,\n          # Conformed to https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1\n          %{\n            \"sub\"   => user[\"id\"],\n            \"name\"  => user[\"name\"],\n            \"email\" => user[\"email\"]\n          # },\n          # # Provider specific data not part of the standard claims spec\n          # %{\n          #  \"https://example.com/bio\" => user[\"bio\"]\n          }\n        }\n      end\n    end","ref":"Assent.Strategy.OAuth2.Base.html#module-usage","title":"Usage - Assent.Strategy.OAuth2.Base","type":"behaviour"},{"doc":"","ref":"Assent.Strategy.OAuth2.Base.html#authorize_url/2","title":"Assent.Strategy.OAuth2.Base.authorize_url/2","type":"function"},{"doc":"","ref":"Assent.Strategy.OAuth2.Base.html#callback/3","title":"Assent.Strategy.OAuth2.Base.callback/3","type":"function"},{"doc":"","ref":"Assent.Strategy.OAuth2.Base.html#c:default_config/1","title":"Assent.Strategy.OAuth2.Base.default_config/1","type":"callback"},{"doc":"","ref":"Assent.Strategy.OAuth2.Base.html#c:fetch_user/2","title":"Assent.Strategy.OAuth2.Base.fetch_user/2","type":"callback"},{"doc":"","ref":"Assent.Strategy.OAuth2.Base.html#c:normalize/2","title":"Assent.Strategy.OAuth2.Base.normalize/2","type":"callback"},{"doc":"OpenID Connect strategy.\n\nThis is built upon the `Assent.Strategy.OAuth2` strategy with added OpenID\nConnect capabilities.","ref":"Assent.Strategy.OIDC.html","title":"Assent.Strategy.OIDC","type":"module"},{"doc":"- `:client_id` - The client id, required\n  - `:site` - The OIDC issuer, required\n  - `:openid_configuration_uri` - The URI for OpenID Provider, optional,\n    defaults to `/.well-known/openid-configuration`\n  - `:client_authentication_method` - The Client Authentication method to\n    use, optional, defaults to `client_secret_basic`\n  - `:client_secret` - The client secret, required if\n    `:client_authentication_method` is `:client_secret_basic`,\n    `:client_secret_post`, or `:client_secret_jwt`\n  - `:openid_configuration` - The OpenID configuration, optional, the\n    configuration will be fetched from `:openid_configuration_uri` if this is\n    not defined\n  - `:id_token_signed_response_alg` - The `id_token_signed_response_alg`\n    parameter sent by the Client during Registration, defaults to `RS256`\n  - `:id_token_ttl_seconds` - The number of seconds from `iat` that an ID\n    Token will be considered valid, optional, defaults to nil\n  - `:nonce` - The nonce to use for authorization request, optional, MUST be\n    session based and unguessable\n  - `:trusted_audiences` - A list of audiences that are trusted, optional.\n\nSee `Assent.Strategy.OAuth2` for more configuration options.","ref":"Assent.Strategy.OIDC.html#module-configuration","title":"Configuration - Assent.Strategy.OIDC","type":"module"},{"doc":"config =  [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      site: \"https://server.example.com\",\n      authorization_params: [scope: \"user:read user:write\"]\n    ]\n\n    {:ok, {url: url, session_params: session_params}} =\n      config\n      |> Assent.Config.put(:redirect_uri, \"http://localhost:4000/auth/callback\")\n      |> Assent.Strategy.OIDC.authorize_url()\n\n    {:ok, %{user: user, token: token}} =\n      config\n      |> Assent.Config.put(:session_params, session_params)\n      |> Assent.Strategy.OIDC.callback(params)","ref":"Assent.Strategy.OIDC.html#module-usage","title":"Usage - Assent.Strategy.OIDC","type":"module"},{"doc":"`:nonce` can be set in the provider config. The `:nonce` will be returned in\nthe `:session_params` along with `:state`. You can use this to store the value\nin the current session e.g. a httpOnly session cookie.\n\nA random value generator can look like this:\n\n    16\n    |> :crypto.strong_rand_bytes()\n    |> Base.encode64(padding: false)\n\nPowAssent will dynamically generate one for the session if `:nonce` is set to\n`true`.\n\nSee `Assent.Strategy.OIDC.authorize_url/1` for more.","ref":"Assent.Strategy.OIDC.html#module-nonce","title":"Nonce - Assent.Strategy.OIDC","type":"module"},{"doc":"Generates an authorization URL for request phase.\n\nThe authorization url will be fetched from the OpenID configuration URI.\n\n`openid` will automatically be added to the `:scope` in\n`:authorization_params`, unless `:openid_default_scope` has been set.\n\nAdd `:nonce` to the config to pass it with the authorization request. The\nnonce will be returned in `:session_params`. The nonce MUST be session based\nand unguessable. A cryptographic hash of a cryptographically random value\ncould be stored in a httpOnly session cookie.\n\nSee `Assent.Strategy.OAuth2.authorize_url/1` for more.","ref":"Assent.Strategy.OIDC.html#authorize_url/1","title":"Assent.Strategy.OIDC.authorize_url/1","type":"function"},{"doc":"Callback phase for generating access token and fetch user data.\n\nThe token url will be fetched from the OpenID configuration URI.\n\nIf the returned ID Token is signed with a symmetric key, `:client_secret`\nwill be required and used to verify the ID Token. If it was signed with a\nprivate key, the appropriate public key will be fetched from the `jwks_uri`\nsetting in the OpenID configuration to verify the ID Token.\n\nThe ID Token will be validated per\n[OpenID Connect Core 1.0 rules](https://openid.net/specs/openid-connect-core-1_0.html#IDTokenValidation).\n\nSee `Assent.Strategy.OAuth2.callback/3` for more.","ref":"Assent.Strategy.OIDC.html#callback/3","title":"Assent.Strategy.OIDC.callback/3","type":"function"},{"doc":"Fetches user params from ID token.\n\nThe ID Token is validated, and the claims is returned as the user params.\nUse `fetch_userinfo/2` to fetch the claims from the `userinfo` endpoint.","ref":"Assent.Strategy.OIDC.html#fetch_user/2","title":"Assent.Strategy.OIDC.fetch_user/2","type":"function"},{"doc":"Fetches claims from userinfo endpoint.\n\nThe userinfo will be fetched from the `userinfo_endpoint` OpenID\nconfiguration.\n\nThe returned claims will be validated against the `id_token` verifying that\n`sub` is equal.","ref":"Assent.Strategy.OIDC.html#fetch_userinfo/2","title":"Assent.Strategy.OIDC.fetch_userinfo/2","type":"function"},{"doc":"Validates the ID token.\n\nThe OpenID configuration will be dynamically fetched if not set in the\nconfig.\n\nThe ID Token will be validated per\n[OpenID Connect Core 1.0 rules](https://openid.net/specs/openid-connect-core-1_0.html#IDTokenValidation).","ref":"Assent.Strategy.OIDC.html#validate_id_token/2","title":"Assent.Strategy.OIDC.validate_id_token/2","type":"function"},{"doc":"OIDC OAuth 2.0 strategy base.","ref":"Assent.Strategy.OIDC.Base.html","title":"Assent.Strategy.OIDC.Base","type":"behaviour"},{"doc":"defmodule MyApp.MyOIDCStrategy do\n      use Assent.Strategy.OIDC.Base\n\n      def default_config(_config) do\n        [\n          site: \"https://oidc.example.com\"\n        ]\n      end\n\n      def normalize(_config, user), do: {:ok, user}\n    end","ref":"Assent.Strategy.OIDC.Base.html#module-usage","title":"Usage - Assent.Strategy.OIDC.Base","type":"behaviour"},{"doc":"","ref":"Assent.Strategy.OIDC.Base.html#authorize_url/2","title":"Assent.Strategy.OIDC.Base.authorize_url/2","type":"function"},{"doc":"","ref":"Assent.Strategy.OIDC.Base.html#callback/3","title":"Assent.Strategy.OIDC.Base.callback/3","type":"function"},{"doc":"","ref":"Assent.Strategy.OIDC.Base.html#c:default_config/1","title":"Assent.Strategy.OIDC.Base.default_config/1","type":"callback"},{"doc":"","ref":"Assent.Strategy.OIDC.Base.html#c:fetch_user/2","title":"Assent.Strategy.OIDC.Base.fetch_user/2","type":"callback"},{"doc":"","ref":"Assent.Strategy.OIDC.Base.html#c:normalize/2","title":"Assent.Strategy.OIDC.Base.normalize/2","type":"callback"},{"doc":"Slack OAuth 2.0 OpenID Connect strategy.\n\nThe Slack user endpoint does not provide data on email verification, email is\nconsidered unverified.","ref":"Assent.Strategy.Slack.html","title":"Assent.Strategy.Slack","type":"module"},{"doc":"- `:team_id` - The team id to restrict authorization for, optional, defaults to nil\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Slack.html#module-configuration","title":"Configuration - Assent.Strategy.Slack","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nBy default, the user can decide what team should be used for authorization.\nIf you want to limit to a specific team, please pass a team id to the\nconfiguration:\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      team_id: \"XXXXXXX\"\n    ]\n\nThis value will be not be used if you set a `authorization_params` key.\nInstead you should set `team: TEAM_ID` in the `authorization_params` keyword\nlist.","ref":"Assent.Strategy.Slack.html#module-usage","title":"Usage - Assent.Strategy.Slack","type":"module"},{"doc":"Spotify OAuth 2.0 strategy.","ref":"Assent.Strategy.Spotify.html","title":"Assent.Strategy.Spotify","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Spotify.html#module-usage","title":"Usage - Assent.Strategy.Spotify","type":"module"},{"doc":"Strava OAuth strategy.\n\nThe athlete endpoint, describing the currently authenticated user, does not\nreturn an email address - [changelog](https://developers.strava.com/docs/changelog/#january-17-2019).","ref":"Assent.Strategy.Strava.html","title":"Assent.Strategy.Strava","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Strava.html#module-usage","title":"Usage - Assent.Strategy.Strava","type":"module"},{"doc":"Stripe Connect OAuth 2.0 strategy.","ref":"Assent.Strategy.Stripe.html","title":"Assent.Strategy.Stripe","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.Stripe.html#module-usage","title":"Usage - Assent.Strategy.Stripe","type":"module"},{"doc":"This strategy uses Connect Standard by default. To use Connect Express, the\nfollowing config can be used:\n\n\n    config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      authorize_url: \"https://connect.stripe.com/express/oauth/authorize\"\n      # authorization_params: [\n      #   stripe_user: [business_type: \"company\", email: \"user@example.com\"],\n      #   suggested_capabilities: [\"transfers\"]\n      # ]\n    ]","ref":"Assent.Strategy.Stripe.html#module-connect-express","title":"Connect Express - Assent.Strategy.Stripe","type":"module"},{"doc":"Twitter OAuth strategy.\n\nThe Twitter user endpoint only returns verified email, `email_verified` will\nalways be `true`.","ref":"Assent.Strategy.Twitter.html","title":"Assent.Strategy.Twitter","type":"module"},{"doc":"config = [\n      consumer_key: \"REPLACE_WITH_CONSUMER_KEY\",\n      consumer_secret: \"REPLACE_WITH_CONSUMER_SECRET\"\n    ]\n\nSee `Assent.Strategy.OAuth` for more.","ref":"Assent.Strategy.Twitter.html#module-usage","title":"Usage - Assent.Strategy.Twitter","type":"module"},{"doc":"VK.com OAuth 2.0 strategy.\n\nThe VK token endpoint does not provide data on email verification, email is\nconsidered unverified.","ref":"Assent.Strategy.VK.html","title":"Assent.Strategy.VK","type":"module"},{"doc":"- `:user_url_params` - Parameters to send along with the user fetch request,\n  optional, defaults to `[]`\n\nSee `Assent.Strategy.OAuth2` for more.","ref":"Assent.Strategy.VK.html#module-configuration","title":"Configuration - Assent.Strategy.VK","type":"module"},{"doc":"config = [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\"\n    ]","ref":"Assent.Strategy.VK.html#module-usage","title":"Usage - Assent.Strategy.VK","type":"module"},{"doc":"HTTP adapter helper module.","ref":"Assent.HTTPAdapter.html","title":"Assent.HTTPAdapter","type":"behaviour"},{"doc":"defmodule MyApp.MyHTTPAdapter do\n      @behaviour Assent.HTTPAdapter\n\n      @impl true\n      def request(method, url, body, headers, opts) do\n        # ...\n      end\n    end","ref":"Assent.HTTPAdapter.html#module-usage","title":"Usage - Assent.HTTPAdapter","type":"behaviour"},{"doc":"","ref":"Assent.HTTPAdapter.html#c:request/5","title":"Assent.HTTPAdapter.request/5","type":"callback"},{"doc":"Sets a user agent header\n\nThe header value will be `Assent-VERSION` with VERSION being the `:vsn` of\n`:assent` app.","ref":"Assent.HTTPAdapter.html#user_agent_header/0","title":"Assent.HTTPAdapter.user_agent_header/0","type":"function"},{"doc":"","ref":"Assent.HTTPAdapter.html#t:body/0","title":"Assent.HTTPAdapter.body/0","type":"type"},{"doc":"","ref":"Assent.HTTPAdapter.html#t:headers/0","title":"Assent.HTTPAdapter.headers/0","type":"type"},{"doc":"","ref":"Assent.HTTPAdapter.html#t:method/0","title":"Assent.HTTPAdapter.method/0","type":"type"},{"doc":"HTTP adapter module for making http requests with Finch.\n\nThe Finch adapter must be configured with the supervisor by passing it as an\noption:\n\n    http_adapter: {Assent.HTTPAdapter.Finch, [supervisor: MyFinch]}\n\nSee `Assent.HTTPAdapter` for more.","ref":"Assent.HTTPAdapter.Finch.html","title":"Assent.HTTPAdapter.Finch","type":"module"},{"doc":"Struct used by HTTP adapters to normalize HTTP responses.","ref":"Assent.HTTPAdapter.HTTPResponse.html","title":"Assent.HTTPAdapter.HTTPResponse","type":"module"},{"doc":"","ref":"Assent.HTTPAdapter.HTTPResponse.html#t:header/0","title":"Assent.HTTPAdapter.HTTPResponse.header/0","type":"type"},{"doc":"","ref":"Assent.HTTPAdapter.HTTPResponse.html#t:t/0","title":"Assent.HTTPAdapter.HTTPResponse.t/0","type":"type"},{"doc":"HTTP adapter module for making http requests with httpc.\n\nSSL support will automatically be enabled if the `:certifi` and\n`:ssl_verify_fun` libraries exists in your project. You can also override\nthe httpc options by updating the configuration:\n\n    http_adapter: {Assent.HTTPAdapter.Httpc, [...]}\n\nSee `Assent.HTTPAdapter` for more.","ref":"Assent.HTTPAdapter.Httpc.html","title":"Assent.HTTPAdapter.Httpc","type":"module"},{"doc":"HTTP adapter module for making http requests with Mint.\n\nMint can be configured by updating the configuration:\n\n    http_adapter: {Assent.HTTPAdapter.Mint, [...]}\n\nSee `Assent.HTTPAdapter` for more.","ref":"Assent.HTTPAdapter.Mint.html","title":"Assent.HTTPAdapter.Mint","type":"module"},{"doc":"JWT adapter helper module.","ref":"Assent.JWTAdapter.html","title":"Assent.JWTAdapter","type":"behaviour"},{"doc":"defmodule MyApp.MyJWTAdapter do\n      @behaviour Assent.JWTAdapter\n\n      @impl true\n      def sign(claims, alg, secret, opts) do\n        # ...\n      end\n\n      @impl true\n      def verify(token, secret, opts) do\n        # ...\n      end\n    end","ref":"Assent.JWTAdapter.html#module-usage","title":"Usage - Assent.JWTAdapter","type":"behaviour"},{"doc":"Loads a private key from the provided configuration","ref":"Assent.JWTAdapter.html#load_private_key/1","title":"Assent.JWTAdapter.load_private_key/1","type":"function"},{"doc":"Generates a signed JSON Web Token signature","ref":"Assent.JWTAdapter.html#sign/4","title":"Assent.JWTAdapter.sign/4","type":"function"},{"doc":"","ref":"Assent.JWTAdapter.html#c:sign/4","title":"Assent.JWTAdapter.sign/4","type":"callback"},{"doc":"Verifies the JSON Web Token signature","ref":"Assent.JWTAdapter.html#verify/3","title":"Assent.JWTAdapter.verify/3","type":"function"},{"doc":"","ref":"Assent.JWTAdapter.html#c:verify/3","title":"Assent.JWTAdapter.verify/3","type":"callback"},{"doc":"JWT adapter module for parsing JSON Web Tokens natively.\n\nSee `Assent.JWTAdapter` for more.","ref":"Assent.JWTAdapter.AssentJWT.html","title":"Assent.JWTAdapter.AssentJWT","type":"module"},{"doc":"JWT adapter module for parsing JSON Web Tokens with JOSE.\n\nSee `Assent.JWTAdapter` for more.","ref":"Assent.JWTAdapter.JOSE.html","title":"Assent.JWTAdapter.JOSE","type":"module"},{"doc":"","ref":"Assent.CallbackCSRFError.html","title":"Assent.CallbackCSRFError","type":"exception"},{"doc":"","ref":"Assent.CallbackCSRFError.html#new/1","title":"Assent.CallbackCSRFError.new/1","type":"function"},{"doc":"","ref":"Assent.CallbackError.html","title":"Assent.CallbackError","type":"exception"},{"doc":"","ref":"Assent.Config.MissingKeyError.html","title":"Assent.Config.MissingKeyError","type":"exception"},{"doc":"","ref":"Assent.Config.MissingKeyError.html#t:t/0","title":"Assent.Config.MissingKeyError.t/0","type":"type"},{"doc":"","ref":"Assent.JWTAdapter.AssentJWT.Error.html","title":"Assent.JWTAdapter.AssentJWT.Error","type":"exception"},{"doc":"","ref":"Assent.MissingParamError.html","title":"Assent.MissingParamError","type":"exception"},{"doc":"","ref":"Assent.MissingParamError.html#new/2","title":"Assent.MissingParamError.new/2","type":"function"},{"doc":"","ref":"Assent.RequestError.html","title":"Assent.RequestError","type":"exception"},{"doc":"","ref":"Assent.RequestError.html#invalid/1","title":"Assent.RequestError.invalid/1","type":"function"},{"doc":"","ref":"Assent.RequestError.html#unexpected/1","title":"Assent.RequestError.unexpected/1","type":"function"},{"doc":"","ref":"Assent.RequestError.html#unreachable/3","title":"Assent.RequestError.unreachable/3","type":"function"},{"doc":"# Assent\n\n[![Github CI](https://github.com/pow-auth/assent/workflows/CI/badge.svg)](https://github.com/pow-auth/assent/actions?query=workflow%3ACI)\n[![hexdocs.pm](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/assent)\n[![hex.pm](https://img.shields.io/hexpm/v/assent.svg?style=flat)](https://hex.pm/packages/assent)\n\nMulti-provider authentication framework.","ref":"README.html","title":"Assent","type":"extras"},{"doc":"* Includes the following base strategies:\n  * OAuth 1.0 - `Assent.Strategy.OAuth`\n  * OAuth 2.0 - `Assent.Strategy.OAuth2`\n  * OpenID Connect - `Assent.Strategy.OIDC`\n* Includes the following provider strategies:\n  * Apple Sign In - `Assent.Strategy.Apple`\n  * Auth0 - `Assent.Strategy.Auth0`\n  * Azure AD - `Assent.Strategy.AzureAD`\n  * Basecamp - `Assent.Strategy.Basecamp`\n  * DigitalOcean - `Assent.Strategy.DigitalOcean`\n  * Discord - `Assent.Strategy.Discord`\n  * Facebook - `Assent.Strategy.Facebook`\n  * Github - `Assent.Strategy.Github`\n  * Gitlab - `Assent.Strategy.Gitlab`\n  * Google - `Assent.Strategy.Google`\n  * Instagram - `Assent.Strategy.Instagram`\n  * LINE Login - `Assent.Strategy.LINE`\n  * Linkedin - `Assent.Strategy.Linkedin`\n  * Spotify - `Assent.Strategy.Spotify`\n  * Strava - `Assent.Strategy.Strava`\n  * Slack - `Assent.Strategy.Slack`\n  * Stripe Connect - `Assent.Strategy.Stripe`\n  * Twitter - `Assent.Strategy.Twitter`\n  * VK - `Assent.Strategy.VK`","ref":"README.html#features","title":"Features - Assent","type":"extras"},{"doc":"Add Assent to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:assent, \"~> 0.2.7\"},\n\n     # Required for SSL validation with :httpc adapter\n    {:certifi, \"~> 2.4\"},\n    {:ssl_verify_fun, \"~> 1.1\"}\n  ]\nend\n```\n\nRun `mix deps.get` to install it.\n\nBy default, `:httpc` will be used for HTTP requests. To compile the app with `:httpc` support, please add `:inets` to `:extra_applications` in `mix.exs`:\n\n```elixir\ndef application do\n  [\n    # ...\n    extra_applications: [\n      # ...\n      :inets\n    ]\n  ]\nend\n```\n\nThis is not necessary if you use another HTTP adapter like Finch.\n\nAssent requires Erlang OTP 22.1 or greater.","ref":"README.html#installation","title":"Installation - Assent","type":"extras"},{"doc":"A strategy consists of two phases; request and callback. In the request phase, the user would normally be redirected to the provider for authentication and then returned to initiate the callback phase.\n\n#","ref":"README.html#getting-started","title":"Getting started - Assent","type":"extras"},{"doc":"```elixir\nconfig = [\n  client_id: \"REPLACE_WITH_CLIENT_ID\",\n  client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n  redirect_uri: \"http://localhost:4000/oauth/callback\"\n]\n\n# Redirect user to provider\n{:ok, %{url: url, session_params: session_params}} =\n  Assent.Strategy.Github.authorize_url(config)\n\n# Handle callback\n{:ok, %{user: user, token: token}} =\n  config\n  |> Assent.Config.put(:session_params, session_params)\n  |> Assent.Strategy.Github.callback(params)\n```\n\n#","ref":"README.html#single-provider-example","title":"Single provider example - Assent","type":"extras"},{"doc":"This is a generalized flow that's similar to what's used in [PowAssent](https://github.com/danschultzer/pow_assent).\n\n```elixir\nconfig :my_app, :strategies,\n  github: [\n    client_id: \"REPLACE_WITH_CLIENT_ID\",\n    client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n    strategy: Assent.Strategy.Github\n  ],\n  # ...\n```\n\n```elixir\ndefmodule MultiProvider do\n  @spec request(atom()) :: {:ok, map()} | {:error, term()}\n  def request(provider) do\n    config = config!(provider)\n\n    config[:strategy].authorize_url(config)\n  end\n\n  @spec callback(atom(), map(), map()) :: {:ok, map()} | {:error, term()}\n  def callback(provider, params, session_params \\\\ %{}) do\n    config =\n      provider\n      |> config!()\n      |> Assent.Config.put(:session_params, session_params)\n\n    config[:strategy].callback(config, params)\n  end\n\n  defp config!(provider) do\n    Application.get_env(:my_app, :strategies)[provider] || raise \"No provider configuration for #{provider}\"\n  end\nend\n```","ref":"README.html#multi-provider-example","title":"Multi-provider example - Assent","type":"extras"},{"doc":"You can create custom strategies. Here's an example of an OAuth 2.0 implementation using `Assent.Strategy.OAuth2.Base`:\n\n```elixir\ndefmodule TestProvider do\n  use Assent.Strategy.OAuth2.Base\n\n  @impl true\n  def default_config(_config) do\n    [\n      site: \"http://localhost:4000/api/v1\", # The base URL to use for any paths below\n      authorize_url: \"http://localhost:4000/oauth/authorize\", # Full URL will not use the `:site` option\n      token_url: \"/oauth/access_token\",\n      user_url: \"/user\",\n      authorization_params: [scope: \"email profile\"],\n      auth_method: :client_secret_post\n    ]\n  end\n\n  @impl true\n  def normalize(_config, user) do\n    {:ok,\n      # Conformed to https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1\n      %{\n        \"sub\"      => user[\"sub\"],\n        \"name\"     => user[\"name\"],\n        \"nickname\" => user[\"username\"],\n        \"email\"    => user[\"email\"]\n      # },\n      # # Provider specific data not part of the standard claims spec\n      # %{\n      #   \"http://localhost:4000/bio\" => user[\"bio\"]\n      }\n    }\n  end\nend\n```\n\nThe normalized user map should conform to the [OpenID Connect Core 1.0 Standard Claims spec](https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1), and should return either `{:ok, userinfo_claims}` or `{:ok, userinfo_claims, additional}`. Any keys defined in the userinfo claims that aren't part of the specs will not be included in the user map. Instead, they should be set in the additional data that will then be merged on top of the userinfo claims excluding any keys that have already been set.\n\nYou can also use `Assent.Strategy`:\n\n```elixir\ndefmodule TestProvider do\n  @behaviour Assent.Strategy\n\n  @spec authorize_url(Keyword.t()) :: {:ok, %{url: binary()}} | {:error, term()}\n  def authorize_url(config) do\n    # Generate authorization url\n  end\n\n  @spec callback(Keyword.t(), map()) :: {:ok, %{user: map(), token: map()}} | {:error, term()}\n  def callback(config, params) do\n    # Handle callback response\n  end\nend\n```","ref":"README.html#custom-provider","title":"Custom provider - Assent","type":"extras"},{"doc":"By default Erlangs built-in `:httpc` is used for requests. SSL verification is automatically enabled when `:certifi` and `:ssl_verify_fun` packages are available. `:httpc` only supports HTTP/1.1.\n\nIf you would like HTTP/2 support, you should consider adding [`Finch`](https://github.com/sneako/finch) to your project.\n\n#","ref":"README.html#http-adapter","title":"HTTP Adapter - Assent","type":"extras"},{"doc":"Update `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:finch, \"~> 0.16\"}\n  ]\nend\n```\n\nEnsure you start the Finch supervisor in your application, and set `:http_adapter` in your provider configuration using your connection pool:\n\n```elixir\nconfig = [\n  client_id: \"REPLACE_WITH_CLIENT_ID\",\n  client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n  http_adapter: {Assent.HTTPAdapter.Finch, supervisor: MyFinch}\n]\n```","ref":"README.html#finch","title":"Finch - Assent","type":"extras"},{"doc":"By default the built-in `Assent.JWTAdapter.AssentJWT` is used for JWT parsing, but you can change it to any third-party library with a custom `Assent.JWTAdapter`. A [JOSE](https://github.com/potatosalad/erlang-jose) adapter `Assent.JWTAdapter.JOSE` is included.\n\nTo use JOSE, update `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:jose, \"~> 1.8\"}\n  ]\nend\n```\n\nAnd pass the `:jwt_adapter` with your provider configuration:\n\n```elixir\nconfig = [\n  client_id: \"REPLACE_WITH_CLIENT_ID\",\n  client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n  jwt_adapter: Assent.JWTAdapter.JOSE\n]\n```","ref":"README.html#jwt-adapter","title":"JWT Adapter - Assent","type":"extras"},{"doc":"(The MIT License)\n\nCopyright (c) 2019-present Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"README.html#license","title":"LICENSE - Assent","type":"extras"},{"doc":"# Changelog","ref":"CHANGELOG.html","title":"Changelog","type":"extras"},{"doc":"* `Assent.Strategy.Strava` added","ref":"CHANGELOG.html#v0-2-7-2023-09-12","title":"v0.2.7 (2023-09-12) - Changelog","type":"extras"},{"doc":"* Added `Assent.HTTPAdapter.Finch`\n* Deprecated `Assent.HTTPAdapter.Mint`","ref":"CHANGELOG.html#v0-2-6-2023-08-26","title":"v0.2.6 (2023-08-26) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.Spotify` added","ref":"CHANGELOG.html#v0-2-5-2023-08-21","title":"v0.2.5 (2023-08-21) - Changelog","type":"extras"},{"doc":"* Fixed bug in `Assent.JWTAdapter.AssentJWT` where `verified?` could be a `{:error, term()}` tuple rather than boolean\n* Improved message on private key file load error","ref":"CHANGELOG.html#v0-2-4-2023-08-20","title":"v0.2.4 (2023-08-20) - Changelog","type":"extras"},{"doc":"* Removed `:castore` version requirement\n* `Assent.Strategy.Httpc.request/5` raises error when SSL certificate can't be validated","ref":"CHANGELOG.html#v0-2-3-2023-03-23","title":"v0.2.3 (2023-03-23) - Changelog","type":"extras"},{"doc":"* Fixed bug to handle 201 success response\n* `Assent.Strategy.OIDC` now has support for multiple audiences\n* `Assent.Strategy.OIDC` now permits any auth method if no `token_endpoint_auth_methods_supported` specified\n* `Assent.Strategy.Linkedin` added","ref":"CHANGELOG.html#v0-2-2-2023-02-27","title":"v0.2.2 (2023-02-27) - Changelog","type":"extras"},{"doc":"* Default to using `Jason` instead of `Poison` for JSON parsing\n* Fixed `Bitwise` warning when running on Elixir 1.14","ref":"CHANGELOG.html#v0-2-1-2022-09-15","title":"v0.2.1 (2022-09-15) - Changelog","type":"extras"},{"doc":"**This release consists of breaking changes.**\n\nIn previous `Assent.Strategy.Slack` strategy, the `sub` user id field consisted of `{SUB}-{TEAM}`. Slack has migrated to OpenID Connect, and the response has been conformed to OIDC. The `sub` will now only consists of the `sub` id, and not include team id. To succesfullly migrate to this release all slack identity records storing the `sub` user id field has to be updated.\n\nIf you wish to continue using the previous `sub` user id a custom OIDC strategy can be used instead:\n\n```elixir\ndefmodule Slack do\n  use Assent.Strategy.OIDC.Base\n\n  alias Assent.Strategy.Slack\n\n  defdelegate default_config(config), to: Slack\n\n  def normalize(config, user) do\n    user = Map.put(user, \"sub\", \"#{user[\"https://slack.com/user_id\"]}-#{user[\"https://slack.com/team_id\"]}\")\n\n    Slack.normalize(config, user)\n  end\nend\n```\n\n* `Assent.Strategy.OIDC.fetch_user/2` now removes the ID token specific keys from the user claims instead of normalizing\n* `Assent.Strategy.OIDC.Base` now adds `normalize/2` to the macro that will include the full user claims in the user params\n* `Assent.Strategy.Slack` now uses OpenID connect instead of legacy OAuth 2.0, please note that the `sub` value may have changed","ref":"CHANGELOG.html#v0-2-0-2022-03-01","title":"v0.2.0 (2022-03-01) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OIDC` bug fixed so it handles unreachable urls correctly","ref":"CHANGELOG.html#v0-1-28-2021-09-30","title":"v0.1.28 (2021-09-30) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OIDC` bug fixed for `normalize/2` macro callback","ref":"CHANGELOG.html#v0-1-27-2021-08-21","title":"v0.1.27 (2021-08-21) - Changelog","type":"extras"},{"doc":"* `Assent.constant_time_compare/2` no longer outputs a deprecation warning for OTP 24","ref":"CHANGELOG.html#v0-1-26-2021-05-27","title":"v0.1.26 (2021-05-27) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.Apple` has been fixed to handle the JSON encoded user in callback params","ref":"CHANGELOG.html#v0-1-25-2021-04-09","title":"v0.1.25 (2021-04-09) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OIDC.Base.authorize_url/2` now has correct type specs","ref":"CHANGELOG.html#v0-1-24-2021-03-22","title":"v0.1.24 (2021-03-22) - Changelog","type":"extras"},{"doc":"Updated to support OTP 24 and no longer support OTP < 22.1\n\n* `Assent.Strategy.OIDC` now handles missing `id_token` in token params","ref":"CHANGELOG.html#v0-1-23-2021-03-01","title":"v0.1.23 (2021-03-01) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OAuth2.fetch_user/4` now accepts headers in arguments\n* `Assent.Strategy.AzureAD` bug fixed so it now uses the `RS256` alg","ref":"CHANGELOG.html#v0-1-22-2021-01-08","title":"v0.1.22 (2021-01-08) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OAuth` now handles missing params in callback phase\n* `Assent.Strategy.Twitter` now handles access denied callback","ref":"CHANGELOG.html#v0-1-21-2020-12-29","title":"v0.1.21 (2020-12-29) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.Stripe` added\n* `Assent.Strategy.to_url/3` now handles nested query params\n* `Assent.Strategy.OAuth2` no longer removes padding for base64 encoding authorization header\n* `Assent.Strategy.OIDC.validate_id_token/2` now supports dynamic OpenID configuration\n* `Assent.Strategy.OIDC.fetch_userinfo/2` now supports dynamic OpenID configuration","ref":"CHANGELOG.html#v0-1-20-2020-12-10","title":"v0.1.20 (2020-12-10) - Changelog","type":"extras"},{"doc":"* Updated docs to detail `:inets` compilation\n* `Assent.OAuth2.authorize_url/1` now returns the state, if defined, from `authorization_params`","ref":"CHANGELOG.html#v0-1-19-2020-11-25","title":"v0.1.19 (2020-11-25) - Changelog","type":"extras"},{"doc":"* Removed `oauther` dependency","ref":"CHANGELOG.html#v0-1-18-2020-11-08","title":"v0.1.18 (2020-11-08) - Changelog","type":"extras"},{"doc":"* Relax `mint` requirement","ref":"CHANGELOG.html#v0-1-17-2020-11-05","title":"v0.1.17 (2020-11-05) - Changelog","type":"extras"},{"doc":"**Warning:** This release has breaking changes.\n\nAll `get_user/2` functions has been renamed to `fetch_user/2` as they return `{:ok, res}`/`{:error, res}` tuples.\n\n* `Assent.OAuth.get/4` removed in favor of `Assent.OAuth.request/6`\n* `Assent.OAuth2.get_access_token/3` renamed to `Assent.OAuth2.grant_access_token/3`\n* `Assent.OAuth2.get/4` removed in favor of `Assent.OAuth2.request/6`","ref":"CHANGELOG.html#v0-1-16-2020-10-21","title":"v0.1.16 (2020-10-21) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OIDC.validate_id_token/2` has a bug fixed where `alg` was not validated correctly\n* `Assent.Strategy.OIDC` now has an `:id_token_signed_response_alg` configuration option\n* `Assent.Strategy.LINE` added","ref":"CHANGELOG.html#v0-1-15-2020-10-18","title":"v0.1.15 (2020-10-18) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OAuth2.get_access_token/3` added\n* `Assent.Strategy.OAuth2.refresh_access_token/3` added\n* `Assent.Strategy.OAuth2.authorization_headers/2` is no long a public function\n* `Assent.Strategy.Apple` updated to handle `name` scope","ref":"CHANGELOG.html#v0-1-14-2020-10-11","title":"v0.1.14 (2020-10-11) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.DigitalOcean` added","ref":"CHANGELOG.html#v0-1-13-2020-07-14","title":"v0.1.13 (2020-07-14) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OAuth2.authorization_headers/2` now capitalizes the token type in the authorization header\n* `Assent.Strategy.OIDC.callback/2` now calls the strategy `get_user/2` method before any ID token validation\n* `Assent.Strategy.OIDC.validate_id_token/2` added\n* `Assent.Strategy.OIDC.fetch_userinfo/2` added\n* `Assent.Strategy.OIDC` no longer fetches the userinfo by default instead using the claims in the ID Token","ref":"CHANGELOG.html#v0-1-12-2020-05-24","title":"v0.1.12 (2020-05-24) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.OAuth2.callback/2` now requires `:session_params` to be set in the config\n* `Assent.Strategy.OIDC.callback/2` now requires `:session_params` to be set in the config\n* `Assent.Strategy.OAuth2` now uses constant time comparison for state\n* `Assent.Strategy.OIDC` now uses constant time comparison for nonce\n* `Assent.Strategy.Httpc.request/5` bug fixed for certificates that has wildcard domain with SAN extension\n* `Assent.Strategy.Mint.request/5` bug fixed for certificates that has wildcard domain with SAN extension","ref":"CHANGELOG.html#v0-1-11-2020-05-16","title":"v0.1.11 (2020-05-16) - Changelog","type":"extras"},{"doc":"Now requires Mint 1.0.0 or higher.\n\n* `Assent.Strategy.Instagram` now accepts `:user_url_request_fields` config option and passes `fields` params to the `/me` point","ref":"CHANGELOG.html#v0-1-10-2020-04-23","title":"v0.1.10 (2020-04-23) - Changelog","type":"extras"},{"doc":"Now requires Elixir 1.7 or higher.\n\n* `Assent.Strategy.Instagram` now uses the Instagram Graph API\n* `Assent.Strategy.OIDC` bug fixed when no `:session_params` set in config","ref":"CHANGELOG.html#v0-1-9-2020-04-23","title":"v0.1.9 (2020-04-23) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.Github` now provides `email_verified` value\n* `Assent.Strategy.Gitlab` now provides `email_verified` value\n* `Assent.Strategy.Google` fixed to provide correct `email_verified` value\n* `Assent.Strategy.Twitter` now provides `email_verified` value","ref":"CHANGELOG.html#v0-1-8-2020-02-15","title":"v0.1.8 (2020-02-15) - Changelog","type":"extras"},{"doc":"* Fix `Assent.HTTPAdapter.Mint` where `:unknown` responses where not handled correctly","ref":"CHANGELOG.html#v0-1-7-2020-02-10","title":"v0.1.7 (2020-02-10) - Changelog","type":"extras"},{"doc":"* `Assent.Strategy.AzureAD` now uses auth code flow instead of hybrid flow","ref":"CHANGELOG.html#v0-1-6-2020-01-30","title":"v0.1.6 (2020-01-30) - Changelog","type":"extras"},{"doc":"* Removed unused `:resource` param in `Assent.Strategy.AzureAD`\n* Added \"email profile\" to scope in `Assent.Strategy.AzureAD`\n* Use `response_mode=form_post` for `Assent.Strategy.AzureAD`\n* Updated `Assent.Strategy.OAuth2` to handle access token request correctly when `:auth_method` is `nil` per RFC specs\n* Changed `Assent.Strategy.Apple` to use OIDC strategy and verify the JWT\n* Changed `Assent.Strategy.OIDC` to update token with the expanded JWT as the `id_token`\n* Fixed bug in `Assent.HTTPAdapter.Mint` with query params not being included in request","ref":"CHANGELOG.html#v0-1-5-2020-01-13","title":"v0.1.5 (2020-01-13) - Changelog","type":"extras"},{"doc":"* Support mint up to `v1.0.x`\n* Fixed bug in `Assent.JWTAdapter.JOSE` where `nil` secret value raised an exception\n* Fixed bug in `Assent.JWTAdapter.AssentJWT` where ECDSA algorithms didn't generate or verify valid signatures","ref":"CHANGELOG.html#v0-1-4-2019-11-09","title":"v0.1.4 (2019-11-09) - Changelog","type":"extras"},{"doc":"* Fixed bug in `Assent.Strategy.Github` where multiple emails for account resulted in the verified primary e-mail not being returned","ref":"CHANGELOG.html#v0-1-3-2019-10-27","title":"v0.1.3 (2019-10-27) - Changelog","type":"extras"},{"doc":"* Require `:redirect_uri` is set in the config of `Assent.Strategy.OAuth2.callback/3` instead of as `redirect_uri` in the params","ref":"CHANGELOG.html#v0-1-2-2019-10-08","title":"v0.1.2 (2019-10-08) - Changelog","type":"extras"},{"doc":"* Relax mint requirement\n* Fix bug in `Assent.HTTPAdapter.Mint` where HTTP/2 responses wasn't parsed correctly","ref":"CHANGELOG.html#v0-1-1-2019-10-07","title":"v0.1.1 (2019-10-07) - Changelog","type":"extras"},{"doc":"* Initial release","ref":"CHANGELOG.html#v0-1-0-2019-10-06","title":"v0.1.0 (2019-10-06) - Changelog","type":"extras"}]}